
; define PINs

#define Data595  PORTB,0
#define Latch595 PORTB,1
#define Clock595 PORTB,2

#define Data595Dir  TRISB,0
#define Latch595Dir TRISB,1
#define Clock595Dir TRISB,2

;************************************************
; Transfer
;************************************************

Transfer595
	MOVLW 8
	MOVWF TMP_1	; high-byte from TMP

Trans_1
	RLF TMP,f	; shift high-bit into carry

; Set Data depending on carry-flag

	BCF Data595
	BTFSC STATUS,CARRY
	BSF Data595

	BSF Clock595	; Clock High
	NOP
	BCF Clock595	; Clock Low

	DECFSZ TMP_1,f
	GOTO Trans_1	; next bit

	BSF Latch595	; all done, confirm
	NOP
	BCF Latch595

	RETURN

;************************************************
