	; start convert ?
	BTFSS DS1820_2,0
	GOTO DS1820_2_MAIN_1 ; no

	CALL DS1820_2_RESET

	MOVLW $CC	; skip ROM
	CALL DS1820_2_WRITE

	MOVLW $44	; start convert
	CALL DS1820_2_WRITE

DS1820_2_MAIN_1

	; read temperature

	BTFSS DS1820_2,1
	GOTO DS1820_2_MAIN_2 ; no

	CALL DS1820_2_RESET

	MOVLW $CC	; skip ROM
	CALL DS1820_2_WRITE
	MOVLW $BE	; read scratch
	CALL DS1820_2_WRITE

	; get low-byte

	CALL DS1820_2_READ
	MOVWF DS1820_2_DATA
	MOVWF DS1820_2_DEG

	; get high-byte

	CALL DS1820_2_READ
	MOVWF DS1820_2_DATA_1
	MOVWF DS1820_2_COMMA

	; negativ ?

	BCF DS1820_2_SIGN,7	; set positiv
	BTFSS DS1820_2_COMMA,7
	GOTO DS1820_2_MAIN_3

	BSF DS1820_2_SIGN,7	; negativ

	; yes, 2nd complement
	COMF DS1820_2_DEG,F
	COMF DS1820_2_COMMA,F
	INCFSZ DS1820_2_DEG,F
	GOTO DS1820_2_MAIN_3
	INCF DS1820_2_COMMA,F

DS1820_2_MAIN_3
	; shift the result right. The carry is the lower bit = 0,5
	RRF DS1820_2_COMMA,F
	RRF DS1820_2_DEG,F

	MOVLW 0
	BTFSC STATUS,CARRY
	MOVLW 5
	MOVWF DS1820_2_COMMA

	CALL DS1820_2_RESET

DS1820_2_MAIN_2

	