	; start convert ?
	BTFSS DS1820,0
	GOTO DS1820_MAIN_1 ; no

	CALL DS1820_RESET

	MOVLW $CC	; skip ROM
	CALL DS1820_WRITE

	MOVLW $44	; start convert
	CALL DS1820_WRITE

DS1820_MAIN_1

	; read temperature

	BTFSS DS1820,1
	GOTO DS1820_MAIN_2 ; no

	CALL DS1820_RESET

	MOVLW $CC	; skip ROM
	CALL DS1820_WRITE
	MOVLW $BE	; read scratch
	CALL DS1820_WRITE

	; get low-byte

	CALL DS1820_READ
	MOVWF DS1820_DATA
	MOVWF DS1820_DEG

	; get high-byte

	CALL DS1820_READ
	MOVWF DS1820_DATA_1
	MOVWF DS1820_COMMA

	; negativ ?

	BCF DS1820_SIGN,7	; set positiv
	BTFSS DS1820_COMMA,7
	GOTO DS1820_MAIN_3

	BSF DS1820_SIGN,7	; negativ

	; yes, 2nd complement
	COMF DS1820_DEG,F
	COMF DS1820_COMMA,F
	INCFSZ DS1820_DEG,F
	GOTO DS1820_MAIN_3
	INCF DS1820_COMMA,F

DS1820_MAIN_3
	; shift the result right. The carry is the lower bit = 0,5
	RRF DS1820_COMMA,F
	RRF DS1820_DEG,F

	MOVLW 0
	BTFSC STATUS,CARRY
	MOVLW 5
	MOVWF DS1820_COMMA

	CALL DS1820_RESET

DS1820_MAIN_2

	