
	; Timer 1 enabled ?
	BTFSS PIE1,TMR1IE
	GOTO NO_T1_INTERRUPT	; no

	; Timer 1 interrupt ?
	BTFSS PIR1,TMR1IF
	GOTO NO_T1_INTERRUPT 	; no

	; Confirm interrupt
	BCF PIR1,TMR1IF

	; Timer 1 is not 0, because it run through.
	; We have to add the new start-value

	MOVLW HIGH 64536
	ADDWF TMR1H,F

	MOVLW LOW 64536
	ADDWF TMR1L,F

	; Overrun ?
	BTFSC STATUS,CARRY
	INCF TMR1H,F ; +1	; yes

	; RA0 toggel
	BTFSC PORTA,0
	GOTO TR1_CLR_RA0

	BSF PORTA,0
	GOTO NO_T1_INTERRUPT

TR1_CLR_RA0
	BCF PORTA,0

NO_T1_INTERRUPT
