
  ; Include at the "end of init"

	; Timer 1 interrupt every 1000 ticks
	; Important: Timer 1 can only count upwards(0..65535)

	; Set Timer 1 to 64536 (65535-1000)
	MOVLW LOW 64536
	MOVWF TMR1L
	MOVLW HIGH 64536
	MOVWF TMR1H

	; Switch TMR1 on
	BSF T1CON,TMR1ON

	; Set RA0 to output
	BCF TRISA,0

	; Enable TMR1 Interrupt
	BSF PIE1,TMR1IE

	; Peripherie Interrupt enable
	BSF INTCON,PEIE

	; Normaly enable global interrupt
	; We dont't need it. Parsic already do it

	; BSF INTCON,GIE
